<template>
  <ob-modal
      ref="list-cars-modal"
      size="extra-large"
      :titleSecond="modalSecondTitle"
  >
    <div v-if="listCarsLenght" class="modal-title">В локациию <i class="icon city account-list__blue"/> {{listCars.startAddress}} следуют</div>
    <div v-if="loader" class="modal-loader">
      <ob-loader
          :width="10"
          :height="10"
          :duration="2"
          class="modal-loader-loading"
      />
    </div>

    <div v-if="!loader" class="modal-body">
      <ob-func-panel :columns="columns" />
      <ob-table
          :items="listCars.coupleList"
          :columns="columns"
          :tableHeight="500"
      >
        <div slot="SignalStatus" slot-scope="{data}">
          <signalStatus :item="signal(data.item)"/>
        </div>
        <div slot="requirements" slot-scope="{data}">
          <requirements :item="data.item"/>
        </div>
        <div slot="tractor" slot-scope="{data}">
          <registrationMark :item="data.item.traktor"/>
        </div>
        <div slot="wagon" slot-scope="{data}">
          <registrationMark :item="data.item.wagon"/>
        </div>
        <div slot="driver" slot-scope="{data}">
          <driver :item="data.item"/>
        </div>
        <div slot="lastOrder" slot-scope="{data}">
          <lastOrder :item="data.item"/>
        </div>
        <div slot="owner" slot-scope="{data}">
          <owner :item="data.item"/>
        </div>
        <div slot="unloadingTime" slot-scope="{data}">
          <unloadingTime :item="data.item"/>
        </div>
        <div slot="powerReserve" slot-scope="{data}">
          <powerReserve :item="data.item"/>
        </div>
      </ob-table>
    </div>

    <div class="modal-footer" style="justify-content: space-between">
      <ob-button
          label="Закрыть"
          @click="$refs['list-cars-modal'].close()"
      />
      <ObMenuDropdown :items="dropdownTabs"/>
    </div>

  </ob-modal>
</template>

<script>
  import ObModal from "common-components/src/obComponents/obModal/index";
  import ObLoader from "common-components/src/obComponents/obLoader";
  import ObFuncPanel from "common-components/src/obComponents/obFuncPanel";
  import ObTable from 'common-components/src/obComponents/obTable';
  import ObButton from "common-components/src/obComponents/obButton";
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
  import signalStatus from './slots/signalStatus';
  import requirements from '../../../../list/slots/requirements';
  import registrationMark from './slots/registrationMark';
  import driver from './slots/driver';
  import lastOrder from './slots/lastOrder';
  import owner from './slots/owner';
  import unloadingTime from './slots/unloadingTime';
  import powerReserve from './slots/powerReserve';
  import {mapActions, mapGetters} from "vuex";

  export default {
    name: "suitable-cars",
    components: {
      ObModal,
      ObLoader,
      ObFuncPanel,
      ObTable,
      ObButton,
      ObMenuDropdown,
      signalStatus,
      requirements,
      registrationMark,
      driver,
      lastOrder,
      owner,
      unloadingTime,
      powerReserve
    },
    computed: {
      ...mapGetters({
        listCars: 'account/listSuitableCars',
        loader: 'account/orderSignalLoader',
      }),
      listCarsLenght() {
        return Object.keys(this.listCars).length;
      },
      modalSecondTitle() {
        return this.listCarsLenght ? `Подходят для заказа ${this.listCars.startAddress} – ${this.listCars.endAddress}` : ''
      }
    },
    data() {
      return {
        columns: [
          {
            title: '',
            key: 'SignalStatus',
            slotName: 'SignalStatus'
          },
          {
            title: '',
            key: 'requirements',
            slotName: 'requirements'
          },
          {
            title: 'Тягач/Фургон',
            key: 'tractor',
            slotName: 'tractor',
            width: '121'
          },
          {
            title: 'Фура',
            key: 'wagon',
            slotName: 'wagon',
            width: '121'
          },
          {
            title: 'Водитель',
            key: 'driver',
            slotName: 'driver'
          },
          {
            title: 'Последний заказ',
            key: 'lastOrder',
            slotName: 'lastOrder',
            width: '145'
          },
          {
            title: 'Грузовладелец',
            key: 'owner',
            slotName: 'owner'
          },
          {
            title: 'Время разгрузки',
            key: 'unloadingTime',
            slotName: 'unloadingTime',
            sort: "datetime",
          },
          {
            title: 'Запас Время/км',
            titleInfo: 'Сколько у вас есть времени между разгрузкой предыдущего заказа и погрузкой нового. Запас километров рассчитан от точки выгрузки предыдущего заказа',
            key: 'powerReserve',
            slotName: 'powerReserve',
            sort: "datetime",
            width: 170,
          }
        ],
        dropdownTabs: [
          {
            icon: 'close',
            title: 'Закрыть',
            method: () => {
              this.$refs['list-cars-modal'].close();
              this.clearDataLogistic()
            }
          }
        ]
      }
    },
    methods: {
      ...mapActions('account', ['clearDataLogistic']),
      signal({status}) {
        return {
          helper_logistic: {
            status: status
          }
        }
      }
    }
  }
</script>

<style scoped lang="scss">
  .modal-title {
    font-size: 28px;
    line-height: 32px;
    color: $Grey-900;
    margin-top: -17px;
  }

  .modal-loader {
    position: relative;
    height: 500px;
    &-loading{
      left: 50%;
      top: 50%;
      position: absolute;
      margin-left: -20px;
      background: $components-printForm-contract_print_form_background_color;
    }
  }
</style>